'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ajv = require('ajv');

var _ajv2 = _interopRequireDefault(_ajv);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function errorToProperty(err) {
  const { params = {} } = err;

  if (params.missingProperty) {
    return params.missingProperty;
  }

  return undefined;
}

class Validator extends _react.Component {

  constructor(props, context) {
    var _this;

    _this = super(props, context);

    this.validate = (() => {
      var _ref = _asyncToGenerator(function* (value) {
        const { validator } = _this.state;
        if (!validator) {
          return [];
        }

        const valid = validator(value);
        if (valid) {
          return [];
        }

        const { errors } = validator;

        return errors.map(function (err) {
          const prop = errorToProperty(err);
          const path = err.dataPath ? err.dataPath.substr(1) : null;

          const fullPath = path && prop ? `${path}.${prop}` : path || prop;

          return _extends({}, err, {
            path: fullPath
          });
        });
      });

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    })();

    this.state = _extends({}, this.getStateFromProps(props));
  }

  componentWillReceiveProps(props) {
    this.setState(this.getStateFromProps(props));
  }

  getStateFromProps(props) {
    const { schema } = props;
    if (!schema) {
      return {
        validator: null
      };
    }

    const currentValidator = this.state && this.state.validator;
    if (!currentValidator || currentValidator.schema !== schema) {
      const ajv = this.ajv = this.ajv || (0, _ajv2.default)({
        allErrors: true
      });

      const validator = ajv.compile(schema);

      validator.schema = schema;

      return {
        validator
      };
    }

    return {};
  }

  render() {
    const { children } = this.props;
    if (!children) {
      return children;
    }

    return (0, _react.cloneElement)(children, {
      validate: this.validate
    });
  }
}
exports.default = Validator;
Validator.propTypes = {
  schema: _propTypes2.default.object,
  children: _propTypes2.default.node
};
//# sourceMappingURL=Validator.js.map